package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
vis = vis | (param.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

 {
            Activity __a = null;
            if (param.previousOne != null) {
				__a = param.previousOne.get();
			}
            else {
                BA ba = param.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, starter.class));
}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _timemaj = null;
public static String _dbdirname = "";
public static String _dbfilename = "";
public static String _timerdateavant = "";
public static anywheresoftware.b4a.sql.SQL _mabase = null;
public static String _txtdate = "";
public static String _txttime = "";
public static long _timerinterval = 0L;
public static long _haut = 0L;
public static long _gauche = 0L;
public anywheresoftware.b4a.objects.EditTextWrapper _lbldate = null;
public static byte _direction = (byte)0;
public anywheresoftware.b4a.objects.ListViewWrapper _listerdv = null;
public static long _limitedroite = 0L;
public static long _limitebas = 0L;
public anywheresoftware.b4a.objects.EditTextWrapper _txtcoord = null;
public b4a.example.param _param = null;
public b4a.example.starter _starter = null;
public b4a.example.module1 _module1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="Activity.LoadLayout(\"EcranPrincipal\")";
mostCurrent._activity.LoadLayout("EcranPrincipal",mostCurrent.activityBA);
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="Try";
try {RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="maBase.Initialize(DBDirName, DBFileName, True)";
_mabase.Initialize(_dbdirname,_dbfilename,anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="maBase.ExecNonQuery(\"CREATE TABLE IF NOT EXISTS";
_mabase.ExecNonQuery("CREATE TABLE IF NOT EXISTS rdv (nordv INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL UNIQUE, dateheure LONG, libelle STRING, liste INTEGER)");
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="maBase.Close";
_mabase.Close();
 } 
       catch (Exception e26) {
			processBA.setLastException(e26);RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
 };
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="timerDateAvant=Module1.DateHeureToStringDate(Dat";
_timerdateavant = mostCurrent._module1._dateheuretostringdate(mostCurrent.activityBA,anywheresoftware.b4a.keywords.Common.DateTime.getNow());
RDebugUtils.currentLine=131087;
 //BA.debugLineNum = 131087;BA.debugLine="AfficheRdv";
_afficherdv();
 };
RDebugUtils.currentLine=131091;
 //BA.debugLineNum = 131091;BA.debugLine="timeMAJ.Initialize(\"timeMAJ\", TimerInterval)";
_timemaj.Initialize(processBA,"timeMAJ",_timerinterval);
RDebugUtils.currentLine=131092;
 //BA.debugLineNum = 131092;BA.debugLine="timeMAJ.Enabled=True";
_timemaj.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=131095;
 //BA.debugLineNum = 131095;BA.debugLine="LimiteDroite= GetDeviceLayoutValues.Width-Module1";
_limitedroite = (long) (anywheresoftware.b4a.keywords.Common.GetDeviceLayoutValues(mostCurrent.activityBA).Width-mostCurrent._module1._maxi(mostCurrent.activityBA,mostCurrent._lbldate.getWidth(),mostCurrent._listerdv.getWidth()));
RDebugUtils.currentLine=131096;
 //BA.debugLineNum = 131096;BA.debugLine="LimiteBas= GetDeviceLayoutValues.Height - LblDate";
_limitebas = (long) (anywheresoftware.b4a.keywords.Common.GetDeviceLayoutValues(mostCurrent.activityBA).Height-mostCurrent._lbldate.getHeight()-mostCurrent._listerdv.getHeight());
RDebugUtils.currentLine=131099;
 //BA.debugLineNum = 131099;BA.debugLine="ListeRdv.SingleLineLayout.Label.TextSize=40 'Haut";
mostCurrent._listerdv.getSingleLineLayout().Label.setTextSize((float) (40));
RDebugUtils.currentLine=131102;
 //BA.debugLineNum = 131102;BA.debugLine="End Sub";
return "";
}
public static String  _afficherdv() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("afficherdv"))
	return (String) Debug.delegate(mostCurrent.activityBA, "afficherdv", null);
anywheresoftware.b4a.sql.SQL.CursorWrapper _enreg = null;
int _i = 0;
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub AfficheRdv";
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="Dim Enreg As Cursor";
_enreg = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
RDebugUtils.currentLine=393221;
 //BA.debugLineNum = 393221;BA.debugLine="ListeRdv.Clear";
mostCurrent._listerdv.Clear();
RDebugUtils.currentLine=393224;
 //BA.debugLineNum = 393224;BA.debugLine="Try";
try {RDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="maBase.Initialize(DBDirName, DBFileName, True)";
_mabase.Initialize(_dbdirname,_dbfilename,anywheresoftware.b4a.keywords.Common.True);
 } 
       catch (Exception e56) {
			processBA.setLastException(e56);RDebugUtils.currentLine=393227;
 //BA.debugLineNum = 393227;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
 };
RDebugUtils.currentLine=393231;
 //BA.debugLineNum = 393231;BA.debugLine="Try";
try {RDebugUtils.currentLine=393232;
 //BA.debugLineNum = 393232;BA.debugLine="Enreg = maBase.ExecQuery(\"SELECT dateheure, l";
_enreg.setObject((android.database.Cursor)(_mabase.ExecQuery("SELECT dateheure, libelle FROM rdv WHERE dateheure >= "+BA.NumberToString(mostCurrent._module1._jourlong(mostCurrent.activityBA))+" and dateheure < "+BA.NumberToString(mostCurrent._module1._demainlong(mostCurrent.activityBA))+" ORDER BY dateheure")));
 } 
       catch (Exception e61) {
			processBA.setLastException(e61);RDebugUtils.currentLine=393234;
 //BA.debugLineNum = 393234;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
 };
RDebugUtils.currentLine=393238;
 //BA.debugLineNum = 393238;BA.debugLine="For i = 0 To Enreg.RowCount - 1";
{
final int step13 = 1;
final int limit13 = (int) (_enreg.getRowCount()-1);
for (_i = (int) (0) ; (step13 > 0 && _i <= limit13) || (step13 < 0 && _i >= limit13); _i = ((int)(0 + _i + step13)) ) {
RDebugUtils.currentLine=393239;
 //BA.debugLineNum = 393239;BA.debugLine="Enreg.Position = i";
_enreg.setPosition(_i);
RDebugUtils.currentLine=393240;
 //BA.debugLineNum = 393240;BA.debugLine="ListeRdv.AddSingleLine(Module1.DateHeureToString";
mostCurrent._listerdv.AddSingleLine(mostCurrent._module1._dateheuretostringheure(mostCurrent.activityBA,(long)(Double.parseDouble(_enreg.GetString("dateheure"))))+"   "+_enreg.GetString("libelle"));
 }
};
RDebugUtils.currentLine=393244;
 //BA.debugLineNum = 393244;BA.debugLine="If Enreg.RowCount=0 Then";
if (_enreg.getRowCount()==0) { 
RDebugUtils.currentLine=393245;
 //BA.debugLineNum = 393245;BA.debugLine="ListeRdv.AddSingleLine(\"              \")";
mostCurrent._listerdv.AddSingleLine("              ");
RDebugUtils.currentLine=393246;
 //BA.debugLineNum = 393246;BA.debugLine="ListeRdv.Height=50dip";
mostCurrent._listerdv.setHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)));
 }else {
RDebugUtils.currentLine=393248;
 //BA.debugLineNum = 393248;BA.debugLine="ListeRdv.Height=ListeRdv.SingleLineLayout.ItemHe";
mostCurrent._listerdv.setHeight((int) (mostCurrent._listerdv.getSingleLineLayout().getItemHeight()*_i));
 };
RDebugUtils.currentLine=393252;
 //BA.debugLineNum = 393252;BA.debugLine="Enreg.Close";
_enreg.Close();
RDebugUtils.currentLine=393253;
 //BA.debugLineNum = 393253;BA.debugLine="maBase.Close";
_mabase.Close();
RDebugUtils.currentLine=393255;
 //BA.debugLineNum = 393255;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_pause"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_pause", new Object[] {_userclosed});
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="timeMAJ.Enabled=True";
_timemaj.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=196612;
 //BA.debugLineNum = 196612;BA.debugLine="End Sub";
return "";
}
public static String  _deplacedate() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("deplacedate"))
	return (String) Debug.delegate(mostCurrent.activityBA, "deplacedate", null);
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub DeplaceDate";
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="Select Case Direction";
switch (BA.switchObjectToInt(_direction,(byte) (1),(byte) (2),(byte) (3),(byte) (4))) {
case 0: {
RDebugUtils.currentLine=524292;
 //BA.debugLineNum = 524292;BA.debugLine="Haut=LblDate.Top+1";
_haut = (long) (mostCurrent._lbldate.getTop()+1);
RDebugUtils.currentLine=524293;
 //BA.debugLineNum = 524293;BA.debugLine="Gauche=LblDate.Left-1";
_gauche = (long) (mostCurrent._lbldate.getLeft()-1);
RDebugUtils.currentLine=524294;
 //BA.debugLineNum = 524294;BA.debugLine="If Haut>=LimiteBas Then Direction=4";
if (_haut>=_limitebas) { 
_direction = (byte) (4);};
RDebugUtils.currentLine=524295;
 //BA.debugLineNum = 524295;BA.debugLine="If Gauche<=0 Then Direction=2";
if (_gauche<=0) { 
_direction = (byte) (2);};
 break; }
case 1: {
RDebugUtils.currentLine=524297;
 //BA.debugLineNum = 524297;BA.debugLine="Haut=LblDate.Top+1";
_haut = (long) (mostCurrent._lbldate.getTop()+1);
RDebugUtils.currentLine=524298;
 //BA.debugLineNum = 524298;BA.debugLine="Gauche=LblDate.Left+1";
_gauche = (long) (mostCurrent._lbldate.getLeft()+1);
RDebugUtils.currentLine=524299;
 //BA.debugLineNum = 524299;BA.debugLine="If Haut>=LimiteBas Then Direction=3";
if (_haut>=_limitebas) { 
_direction = (byte) (3);};
RDebugUtils.currentLine=524300;
 //BA.debugLineNum = 524300;BA.debugLine="If Gauche>=LimiteDroite Then Direction=1";
if (_gauche>=_limitedroite) { 
_direction = (byte) (1);};
 break; }
case 2: {
RDebugUtils.currentLine=524302;
 //BA.debugLineNum = 524302;BA.debugLine="Haut=LblDate.Top-1";
_haut = (long) (mostCurrent._lbldate.getTop()-1);
RDebugUtils.currentLine=524303;
 //BA.debugLineNum = 524303;BA.debugLine="Gauche=LblDate.Left+1";
_gauche = (long) (mostCurrent._lbldate.getLeft()+1);
RDebugUtils.currentLine=524304;
 //BA.debugLineNum = 524304;BA.debugLine="If Haut<=0 Then Direction=2";
if (_haut<=0) { 
_direction = (byte) (2);};
RDebugUtils.currentLine=524305;
 //BA.debugLineNum = 524305;BA.debugLine="If Gauche>=LimiteDroite Then Direction=4";
if (_gauche>=_limitedroite) { 
_direction = (byte) (4);};
 break; }
case 3: {
RDebugUtils.currentLine=524307;
 //BA.debugLineNum = 524307;BA.debugLine="Haut=LblDate.Top-1";
_haut = (long) (mostCurrent._lbldate.getTop()-1);
RDebugUtils.currentLine=524308;
 //BA.debugLineNum = 524308;BA.debugLine="Gauche=LblDate.Left-1";
_gauche = (long) (mostCurrent._lbldate.getLeft()-1);
RDebugUtils.currentLine=524309;
 //BA.debugLineNum = 524309;BA.debugLine="If Haut<=0 Then Direction=1";
if (_haut<=0) { 
_direction = (byte) (1);};
RDebugUtils.currentLine=524310;
 //BA.debugLineNum = 524310;BA.debugLine="If Gauche<=0 Then Direction=3";
if (_gauche<=0) { 
_direction = (byte) (3);};
 break; }
}
;
RDebugUtils.currentLine=524313;
 //BA.debugLineNum = 524313;BA.debugLine="LblDate.Top=Haut";
mostCurrent._lbldate.setTop((int) (_haut));
RDebugUtils.currentLine=524314;
 //BA.debugLineNum = 524314;BA.debugLine="LblDate.Left=Gauche";
mostCurrent._lbldate.setLeft((int) (_gauche));
RDebugUtils.currentLine=524315;
 //BA.debugLineNum = 524315;BA.debugLine="ListeRdv.Top=Haut+LblDate.Height";
mostCurrent._listerdv.setTop((int) (_haut+mostCurrent._lbldate.getHeight()));
RDebugUtils.currentLine=524316;
 //BA.debugLineNum = 524316;BA.debugLine="ListeRdv.Left=Gauche";
mostCurrent._listerdv.setLeft((int) (_gauche));
RDebugUtils.currentLine=524318;
 //BA.debugLineNum = 524318;BA.debugLine="End Sub";
return "";
}
public static String  _listerdv_itemlongclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("listerdv_itemlongclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "listerdv_itemlongclick", new Object[] {_position,_value});
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub ListeRdv_ItemLongClick (Position As Int, Value";
RDebugUtils.currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="StartActivity(\"Param\")";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)("Param"));
RDebugUtils.currentLine=589828;
 //BA.debugLineNum = 589828;BA.debugLine="End Sub";
return "";
}
public static String  _majheure() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("majheure"))
	return (String) Debug.delegate(mostCurrent.activityBA, "majheure", null);
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub majHeure";
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="DateTime.DateFormat=\"EEEE dd MMMM yyyy\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("EEEE dd MMMM yyyy");
RDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="txtDate=DateTime.Date(DateTime.Now)";
mostCurrent._txtdate = anywheresoftware.b4a.keywords.Common.DateTime.Date(anywheresoftware.b4a.keywords.Common.DateTime.getNow());
RDebugUtils.currentLine=458757;
 //BA.debugLineNum = 458757;BA.debugLine="DateTime.TimeFormat=\"HH : mm\"";
anywheresoftware.b4a.keywords.Common.DateTime.setTimeFormat("HH : mm");
RDebugUtils.currentLine=458758;
 //BA.debugLineNum = 458758;BA.debugLine="txtTime=DateTime.Time(DateTime.Now)";
mostCurrent._txttime = anywheresoftware.b4a.keywords.Common.DateTime.Time(anywheresoftware.b4a.keywords.Common.DateTime.getNow());
RDebugUtils.currentLine=458760;
 //BA.debugLineNum = 458760;BA.debugLine="LblDate.Text=txtDate & Chr(10) & txtTime";
mostCurrent._lbldate.setText((Object)(mostCurrent._txtdate+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+mostCurrent._txttime));
RDebugUtils.currentLine=458762;
 //BA.debugLineNum = 458762;BA.debugLine="End Sub";
return "";
}
public static String  _timemaj_tick() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("timemaj_tick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "timemaj_tick", null);
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub timeMAJ_Tick";
RDebugUtils.currentLine=262147;
 //BA.debugLineNum = 262147;BA.debugLine="majHeure";
_majheure();
RDebugUtils.currentLine=262150;
 //BA.debugLineNum = 262150;BA.debugLine="If Module1.DateHeureToStringDate(DateTime.Now)<>t";
if ((mostCurrent._module1._dateheuretostringdate(mostCurrent.activityBA,anywheresoftware.b4a.keywords.Common.DateTime.getNow())).equals(_timerdateavant) == false) { 
RDebugUtils.currentLine=262151;
 //BA.debugLineNum = 262151;BA.debugLine="AfficheRdv";
_afficherdv();
RDebugUtils.currentLine=262152;
 //BA.debugLineNum = 262152;BA.debugLine="timerDateAvant=Module1.DateHeureToStringDate(Dat";
_timerdateavant = mostCurrent._module1._dateheuretostringdate(mostCurrent.activityBA,anywheresoftware.b4a.keywords.Common.DateTime.getNow());
 };
RDebugUtils.currentLine=262156;
 //BA.debugLineNum = 262156;BA.debugLine="DeplaceDate";
_deplacedate();
RDebugUtils.currentLine=262158;
 //BA.debugLineNum = 262158;BA.debugLine="End Sub";
return "";
}
}