﻿Type=Activity
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim maBase As SQL
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Type twoStrings (aLabel As String , bLabel As String)	
	Private ListeRdvParam As ListView
	Private boutValid, boutModif As Button
	Private txtLibelle As AutoCompleteEditText
	Private lstJour As Spinner
	Private lstmois As Spinner
	Private lstAnnee As Spinner
	Private lstHeure As Spinner
	Private lstMinute As Spinner
	Private ljour, lmois, lannee, lheure, lminute As String
	Dim lblLabelA, lblLabelB As String
	Private boutTousRdv As ToggleButton
	
End Sub

Sub Activity_Create(FirstTime As Boolean)

	'Ouvrir l'écran des paramètres
	Activity.LoadLayout("Parametres")

	'Initialiser la listview des rdv
    ListeRdvParam.TwoLinesLayout.ItemHeight = 40dip
    ListeRdvParam.TwoLinesLayout.Label.Top = 0
    ListeRdvParam.TwoLinesLayout.Label.Left = 0
    ListeRdvParam.TwoLinesLayout.Label.Width = 50%x
    ListeRdvParam.TwoLinesLayout.Label.Height = 40dip
    ListeRdvParam.TwoLinesLayout.Label.Gravity = Gravity.CENTER_VERTICAL
    'ListeRdvParam.TwoLinesLayout.Label.Color = Colors.Transparent
    ListeRdvParam.TwoLinesLayout.Label.TextSize = 20
    
    ListeRdvParam.TwoLinesLayout.SecondLabel.Top = 0
    ListeRdvParam.TwoLinesLayout.SecondLabel.Left = 40dip
    ListeRdvParam.TwoLinesLayout.SecondLabel.Width = ListeRdvParam.Width-40
    ListeRdvParam.TwoLinesLayout.SecondLabel.Height = 40dip
    ListeRdvParam.TwoLinesLayout.SecondLabel.Gravity = Gravity.CENTER_VERTICAL
    'ListeRdvParam.TwoLinesLayout.SecondLabel.Color = Colors.Blue
    'ListeRdvParam.TwoLinesLayout.SecondLabel.TextColor = Colors.Yellow
    ListeRdvParam.TwoLinesLayout.SecondLabel.TextSize = 20	

	lireBase
	InitListes
	
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub BoutFermer_Click
	
	StartActivity("Main")
	
End Sub

Sub lireBase
	
	Dim stSql, st As String
	Dim Enreg As Cursor
	Dim ts As twoStrings

	' Ouvrir la base de données
	Try
		maBase.Initialize(Main.DBDirName, Main.DBFileName, True)
	Catch
       	Msgbox(LastException.Message,"")
	End Try
	
	' Lire le fichier
	If boutTousRdv.Checked = True Then 'Prochains rdv
		stSql="SELECT nordv, dateheure, libelle FROM rdv WHERE dateheure >= " & Module1.JourLong & " ORDER BY dateheure"
	Else 'tous les rendez vous
		stSql="SELECT nordv, dateheure, libelle FROM rdv ORDER BY dateheure"
	End If

	Try
		Enreg = maBase.ExecQuery(stSql)
	Catch
       	Msgbox(LastException.Message,"")
		Return
	End Try

	' Afficher les données dans la listview
	ListeRdvParam.Clear
   
    For i = 0 To Enreg.RowCount - 1
       	Enreg.Position=i
		ts.Initialize
		ts.aLabel=Enreg.GetLong("nordv")
		st=Module1.DateHeureToStringDate(Enreg.GetString("dateheure")) & " | "
		st=st & Module1.DateHeureToStringHeure(Enreg.GetString("dateheure")) & " | "
		st=st & Enreg.GetString("libelle")
		ts.bLabel= st
		'ListeRdvParam.AddTwoLines(ts.aLabel, ts.bLabel)
		ListeRdvParam.AddTwoLines2(ts.aLabel, ts.bLabel,ts)
    Next

	'Fermer la base de données
	Enreg.Close
	maBase.Close

End Sub

Sub boutValid_Click 'Nouveau rdv

	Dim keyboard As IME
	Dim sDate, sHeure As String
	Dim H As Long	
	
	'Cacher le clavier
	keyboard.Initialize("")
	keyboard.HideKeyboard

	'Vérifier la saisie
	If VerifSaisie<>"Indiquer " Then 
		Msgbox(VerifSaisie, "Erreur")
		Return
	End If	
	
	' Ouvrir la base de données
	Try
		maBase.Initialize(Main.DBDirName, Main.DBFileName, True)
	Catch
       	Msgbox(LastException.Message,"")
	End Try

	' Mettre en forme les données
	sDate=ljour & "/" & lmois & "/" & lannee
	sHeure=lheure & ":" & lminute
	H=Module1.StringToDateHeure(sDate, sHeure)

	'Ecrire dans la base
	Try
		maBase.ExecNonQuery("INSERT INTO rdv VALUES (null,'" & H & "','" & txtLibelle.Text & "',null)")
	Catch
       	Msgbox(LastException.Message,"")
		Return
	End Try	
	
	ToastMessageShow("Rendez vous créé",False)

	'Fermer la base de données
	maBase.Close
	RazListes
	lireBase
	
End Sub

Sub InitListes
	Dim i As Long
	Dim s As String
	
	'Liste des jours
	lstJour.Add("jour")
	For i = 1 To 31
		s=NumberFormat(i,2,0)
		lstJour.Add(s)
	Next
	' Liste des mois
	lstmois.Add("mois")
	For i = 1 To 12
		s=NumberFormat(i,2,0)
		lstmois.Add(s)
	Next
	' Liste des annees
	lstAnnee.Add("année")
	For i = 2015 To 2050
		lstAnnee.Add(i)
	Next
	' Liste des heures
	lstHeure.Add("heure")
	For i = 0 To 24
		s=NumberFormat(i,2,0)
		lstHeure.Add(s)
	Next
	' Liste des minutes
	lstMinute.Add("minutes")
	For i = 0 To 55 Step 5
		s=NumberFormat(i,2,0)
		lstMinute.Add(s)
	Next
	
End Sub

Sub lstmois_ItemClick (Position As Int, Value As Object)
	lmois=Value
	End Sub

Sub lstMinute_ItemClick (Position As Int, Value As Object)
	lminute=Value
End Sub

Sub lstJour_ItemClick (Position As Int, Value As Object)
	ljour=Value
End Sub

Sub lstHeure_ItemClick (Position As Int, Value As Object)
	lheure=Value
End Sub

Sub lstAnnee_ItemClick (Position As Int, Value As Object)
	lannee=Value
End Sub

Sub VerifSaisie As String
	'Vérification Saisie
	Dim msg As String = "Indiquer "
	If ljour="" Or ljour="jour" Then msg=msg & "Jour "
	If lmois="" Or lmois="mois" Then msg=msg & "Mois "
	If lannee="" Or lannee="année" Then msg=msg & "Annee "
	If lheure="" Or lheure="heure" Then msg=msg & "Heure "
	If lminute="" Or lminute="minutes" Then msg=msg & "Minutes "	
	If txtLibelle.Text="" Then msg=msg & "Libelle "
	Return msg 
End Sub

Sub RazListes
	lstJour.SelectedIndex=0
	lstmois.SelectedIndex=0
	lstAnnee.SelectedIndex=0
	lstHeure.SelectedIndex=0
	lstMinute.SelectedIndex=0
	txtLibelle.Text=""
End Sub

Sub ListeRdvParam_itemlongclick(Position As Int, Value As Object) 'supprimer ou modifier un rdv
	
	Dim ts As twoStrings
	
	' Récupérer la Ligne sélectionnée
    ts.Initialize
   	ts=Value
   	lblLabelA=ts.aLabel
   	lblLabelB=ts.bLabel
					
	' Ouvrir la base de donnees
	Try
		maBase.Initialize(Main.DBDirName, Main.DBFileName, True)
	Catch
       	Msgbox(LastException.Message,"")
	End Try					
							
	'Choix modifier ou supprimer
	Dim Reponse As Int = Msgbox2("Voulez vous supprimer ou modifier cet enregistrement ?" & lblLabelA,"Mise à jour","Modifier", "Annuler", "Supprimer",Null)

	Select Case Reponse

		Case DialogResponse.POSITIVE 'Modifier******************************************************************************************

				Dim stSql, Val  As String
				Dim Enregistrement As Cursor
				Dim t As Long
				
				stSql="SELECT dateheure, libelle FROM rdv WHERE nordv = " & lblLabelA
				
				'Lire la base de données
				Try
					Enregistrement=maBase.ExecQuery(stSql)
				Catch
       				Msgbox(LastException.Message,"")
				End Try	

				'Lire l'enregistrement				
				Enregistrement.Position=0
				t=Enregistrement.GetString("dateheure")
				Val=Enregistrement.GetString("libelle")
				
				'Remplir les zones de saisie
				ljour=DateTime.GetDayOfMonth(t)
					lstJour.SelectedIndex=ljour
				lmois=DateTime.GetMonth(t)
					lstmois.SelectedIndex=lmois
				lannee=DateTime.GetYear(t)
					lstAnnee.SelectedIndex=lannee-2014
				
				lheure=DateTime.GetHour(t)
					lstHeure.SelectedIndex=lheure+1
				lminute=DateTime.GetMinute(t)
					lstMinute.SelectedIndex=lminute/5+1

				txtLibelle.Text=Val

				'Faire apparaitre le bouton Modifier
				boutValid.Visible=False		
				boutModif.visible=True		
				
		Case DialogResponse.CANCEL 'Annuler*********************************************************************************************
			Return
						
		Case DialogResponse.NEGATIVE 'Supprimer*****************************************************************************************

			If Msgbox2("Confirmer la suppression de ce rendez-vous" & Chr(10) & lblLabelB,"Supression","Supprimer","Annuler","",Null)=DialogResponse.POSITIVE Then
				
				stSql="DELETE FROM rdv WHERE nordv = " & lblLabelA
				
				'Supprimer l'enregistrement
				Try
					maBase.ExecNonQuery(stSql)
				Catch
       				Msgbox(LastException.Message,"")
				End Try	
				
				ToastMessageShow("Rendez vous supprimé",False)
				
				lireBase
			Else
				Return
			End If
			
	End Select
	
	'Fermer la base de donnees
	maBase.Close
	
End Sub

Sub BoutModif_Click

	Dim stsql As String
	Dim keyboard As IME
	Dim sDate, sHeure As String
	Dim H As Long
	
	'Cacher le clavier
	keyboard.Initialize("")
	keyboard.HideKeyboard

	'Vérifier la saisie
	If VerifSaisie<>"Indiquer " Then 
		Msgbox(VerifSaisie, "Erreur")
		Return
	End If	
	
	' Ouvrir la base de donnees
'	Try
'		maBase.Initialize(Main.DBDirName, Main.DBFileName, True)
'	Catch
'       	Msgbox(LastException.Message,"")
'	End Try

	'Formater les variables
	sDate=ljour & "/" & lmois & "/" & lannee
	sHeure=lheure & ":" & lminute
	H=Module1.StringToDateHeure(sDate, sHeure)

	stsql="UPDATE rdv SET dateheure=" & H & ", libelle='" & txtLibelle.Text & "' WHERE nordv = " & lblLabelA

	'Modifier le fichier	
	maBase.ExecNonQuery(stsql)
	
	ToastMessageShow("Rendez vous modifié",False)
	
	'Fermer la base
'	maBase.Close
	RazListes
	lireBase
	
	'Faire apparaitre le bouton Créer
	boutValid.Visible=True		
	boutModif.visible=False	
	
End Sub

Sub ListeRdvParam_ItemClick (Position As Int, Value As Object)

	Dim ts As twoStrings
	
	' Récupérer la Ligne sélectionnée
	'Ne fonctionne pas : renvoie toujours le dernier item
	'Remplir avec 		ListeRdvParam.AddTwoLines2(ts.aLabel, ts.bLabel,ts)     sinon erreur
    ts.Initialize
   	ts=Value
   	lblLabelA=ts.aLabel
   	lblLabelB=ts.bLabel
	Msgbox(Position & "/" & lblLabelA & "/" & lblLabelB,"")

	'Cela fonctionne : renvoie la 1ère colonne = index dans la base de données
	'A condition de remplir avec 		ListeRdvParam.AddTwoLines(ts.aLabel, ts.bLabel)
	'Msgbox(Value,"")

End Sub

Sub boutTousRdv_CheckedChange(Checked As Boolean) 'Afficher tous les rdv ou les prochains
	
	lireBase
	
End Sub