package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class param extends Activity implements B4AActivity{
	public static param mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.param");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (param).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.param");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.param", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (param) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (param) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return param.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (param) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (param) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}


public static class _twostrings{
public boolean IsInitialized;
public String aLabel;
public String bLabel;
public void Initialize() {
IsInitialized = true;
aLabel = "";
bLabel = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}

public static void initializeProcessGlobals() {
             try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.sql.SQL _mabase = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listerdvparam = null;
public anywheresoftware.b4a.objects.ButtonWrapper _boutvalid = null;
public anywheresoftware.b4a.objects.ButtonWrapper _boutmodif = null;
public anywheresoftware.b4a.objects.AutoCompleteEditTextWrapper _txtlibelle = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _lstjour = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _lstmois = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _lstannee = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _lstheure = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _lstminute = null;
public static String _ljour = "";
public static String _lmois = "";
public static String _lannee = "";
public static String _lheure = "";
public static String _lminute = "";
public static String _lbllabela = "";
public static String _lbllabelb = "";
public anywheresoftware.b4a.objects.CompoundButtonWrapper.ToggleButtonWrapper _bouttousrdv = null;
public b4a.example.main _main = null;
public b4a.example.starter _starter = null;
public b4a.example.module1 _module1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
RDebugUtils.currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=786435;
 //BA.debugLineNum = 786435;BA.debugLine="Activity.LoadLayout(\"Parametres\")";
mostCurrent._activity.LoadLayout("Parametres",mostCurrent.activityBA);
RDebugUtils.currentLine=786438;
 //BA.debugLineNum = 786438;BA.debugLine="ListeRdvParam.TwoLinesLayout.ItemHeight = 40di";
mostCurrent._listerdvparam.getTwoLinesLayout().setItemHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (40)));
RDebugUtils.currentLine=786439;
 //BA.debugLineNum = 786439;BA.debugLine="ListeRdvParam.TwoLinesLayout.Label.Top = 0";
mostCurrent._listerdvparam.getTwoLinesLayout().Label.setTop((int) (0));
RDebugUtils.currentLine=786440;
 //BA.debugLineNum = 786440;BA.debugLine="ListeRdvParam.TwoLinesLayout.Label.Left = 0";
mostCurrent._listerdvparam.getTwoLinesLayout().Label.setLeft((int) (0));
RDebugUtils.currentLine=786441;
 //BA.debugLineNum = 786441;BA.debugLine="ListeRdvParam.TwoLinesLayout.Label.Width = 50%";
mostCurrent._listerdvparam.getTwoLinesLayout().Label.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA));
RDebugUtils.currentLine=786442;
 //BA.debugLineNum = 786442;BA.debugLine="ListeRdvParam.TwoLinesLayout.Label.Height = 40";
mostCurrent._listerdvparam.getTwoLinesLayout().Label.setHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (40)));
RDebugUtils.currentLine=786443;
 //BA.debugLineNum = 786443;BA.debugLine="ListeRdvParam.TwoLinesLayout.Label.Gravity = G";
mostCurrent._listerdvparam.getTwoLinesLayout().Label.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL);
RDebugUtils.currentLine=786445;
 //BA.debugLineNum = 786445;BA.debugLine="ListeRdvParam.TwoLinesLayout.Label.TextSize =";
mostCurrent._listerdvparam.getTwoLinesLayout().Label.setTextSize((float) (20));
RDebugUtils.currentLine=786447;
 //BA.debugLineNum = 786447;BA.debugLine="ListeRdvParam.TwoLinesLayout.SecondLabel.Top =";
mostCurrent._listerdvparam.getTwoLinesLayout().SecondLabel.setTop((int) (0));
RDebugUtils.currentLine=786448;
 //BA.debugLineNum = 786448;BA.debugLine="ListeRdvParam.TwoLinesLayout.SecondLabel.Left";
mostCurrent._listerdvparam.getTwoLinesLayout().SecondLabel.setLeft(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (40)));
RDebugUtils.currentLine=786449;
 //BA.debugLineNum = 786449;BA.debugLine="ListeRdvParam.TwoLinesLayout.SecondLabel.Width";
mostCurrent._listerdvparam.getTwoLinesLayout().SecondLabel.setWidth((int) (mostCurrent._listerdvparam.getWidth()-40));
RDebugUtils.currentLine=786450;
 //BA.debugLineNum = 786450;BA.debugLine="ListeRdvParam.TwoLinesLayout.SecondLabel.Heigh";
mostCurrent._listerdvparam.getTwoLinesLayout().SecondLabel.setHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (40)));
RDebugUtils.currentLine=786451;
 //BA.debugLineNum = 786451;BA.debugLine="ListeRdvParam.TwoLinesLayout.SecondLabel.Gravi";
mostCurrent._listerdvparam.getTwoLinesLayout().SecondLabel.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL);
RDebugUtils.currentLine=786454;
 //BA.debugLineNum = 786454;BA.debugLine="ListeRdvParam.TwoLinesLayout.SecondLabel.TextS";
mostCurrent._listerdvparam.getTwoLinesLayout().SecondLabel.setTextSize((float) (20));
RDebugUtils.currentLine=786456;
 //BA.debugLineNum = 786456;BA.debugLine="lireBase";
_lirebase();
RDebugUtils.currentLine=786457;
 //BA.debugLineNum = 786457;BA.debugLine="InitListes";
_initlistes();
RDebugUtils.currentLine=786459;
 //BA.debugLineNum = 786459;BA.debugLine="End Sub";
return "";
}
public static String  _lirebase() throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("lirebase"))
	return (String) Debug.delegate(mostCurrent.activityBA, "lirebase", null);
String _stsql = "";
String _st = "";
anywheresoftware.b4a.sql.SQL.CursorWrapper _enreg = null;
b4a.example.param._twostrings _ts = null;
int _i = 0;
RDebugUtils.currentLine=1048576;
 //BA.debugLineNum = 1048576;BA.debugLine="Sub lireBase";
RDebugUtils.currentLine=1048578;
 //BA.debugLineNum = 1048578;BA.debugLine="Dim stSql, st As String";
_stsql = "";
_st = "";
RDebugUtils.currentLine=1048579;
 //BA.debugLineNum = 1048579;BA.debugLine="Dim Enreg As Cursor";
_enreg = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
RDebugUtils.currentLine=1048580;
 //BA.debugLineNum = 1048580;BA.debugLine="Dim ts As twoStrings";
_ts = new b4a.example.param._twostrings();
RDebugUtils.currentLine=1048583;
 //BA.debugLineNum = 1048583;BA.debugLine="Try";
try {RDebugUtils.currentLine=1048584;
 //BA.debugLineNum = 1048584;BA.debugLine="maBase.Initialize(Main.DBDirName, Main.DBFileNam";
_mabase.Initialize(mostCurrent._main._dbdirname,mostCurrent._main._dbfilename,anywheresoftware.b4a.keywords.Common.True);
 } 
       catch (Exception e49) {
			processBA.setLastException(e49);RDebugUtils.currentLine=1048586;
 //BA.debugLineNum = 1048586;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
 };
RDebugUtils.currentLine=1048590;
 //BA.debugLineNum = 1048590;BA.debugLine="If boutTousRdv.Checked = True Then 'Prochains rdv";
if (mostCurrent._bouttousrdv.getChecked()==anywheresoftware.b4a.keywords.Common.True) { 
RDebugUtils.currentLine=1048591;
 //BA.debugLineNum = 1048591;BA.debugLine="stSql=\"SELECT nordv, dateheure, libelle FROM rdv";
_stsql = "SELECT nordv, dateheure, libelle FROM rdv WHERE dateheure >= "+BA.NumberToString(mostCurrent._module1._jourlong(mostCurrent.activityBA))+" ORDER BY dateheure";
 }else {
RDebugUtils.currentLine=1048593;
 //BA.debugLineNum = 1048593;BA.debugLine="stSql=\"SELECT nordv, dateheure, libelle FROM rdv";
_stsql = "SELECT nordv, dateheure, libelle FROM rdv ORDER BY dateheure";
 };
RDebugUtils.currentLine=1048596;
 //BA.debugLineNum = 1048596;BA.debugLine="Try";
try {RDebugUtils.currentLine=1048597;
 //BA.debugLineNum = 1048597;BA.debugLine="Enreg = maBase.ExecQuery(stSql)";
_enreg.setObject((android.database.Cursor)(_mabase.ExecQuery(_stsql)));
 } 
       catch (Exception e59) {
			processBA.setLastException(e59);RDebugUtils.currentLine=1048599;
 //BA.debugLineNum = 1048599;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
RDebugUtils.currentLine=1048600;
 //BA.debugLineNum = 1048600;BA.debugLine="Return";
if (true) return "";
 };
RDebugUtils.currentLine=1048604;
 //BA.debugLineNum = 1048604;BA.debugLine="ListeRdvParam.Clear";
mostCurrent._listerdvparam.Clear();
RDebugUtils.currentLine=1048606;
 //BA.debugLineNum = 1048606;BA.debugLine="For i = 0 To Enreg.RowCount - 1";
{
final int step21 = 1;
final int limit21 = (int) (_enreg.getRowCount()-1);
for (_i = (int) (0) ; (step21 > 0 && _i <= limit21) || (step21 < 0 && _i >= limit21); _i = ((int)(0 + _i + step21)) ) {
RDebugUtils.currentLine=1048607;
 //BA.debugLineNum = 1048607;BA.debugLine="Enreg.Position=i";
_enreg.setPosition(_i);
RDebugUtils.currentLine=1048608;
 //BA.debugLineNum = 1048608;BA.debugLine="ts.Initialize";
_ts.Initialize();
RDebugUtils.currentLine=1048609;
 //BA.debugLineNum = 1048609;BA.debugLine="ts.aLabel=Enreg.GetLong(\"nordv\")";
_ts.aLabel = BA.NumberToString(_enreg.GetLong("nordv"));
RDebugUtils.currentLine=1048610;
 //BA.debugLineNum = 1048610;BA.debugLine="st=Module1.DateHeureToStringDate(Enreg.GetString";
_st = mostCurrent._module1._dateheuretostringdate(mostCurrent.activityBA,(long)(Double.parseDouble(_enreg.GetString("dateheure"))))+" | ";
RDebugUtils.currentLine=1048611;
 //BA.debugLineNum = 1048611;BA.debugLine="st=st & Module1.DateHeureToStringHeure(Enreg.Get";
_st = _st+mostCurrent._module1._dateheuretostringheure(mostCurrent.activityBA,(long)(Double.parseDouble(_enreg.GetString("dateheure"))))+" | ";
RDebugUtils.currentLine=1048612;
 //BA.debugLineNum = 1048612;BA.debugLine="st=st & Enreg.GetString(\"libelle\")";
_st = _st+_enreg.GetString("libelle");
RDebugUtils.currentLine=1048613;
 //BA.debugLineNum = 1048613;BA.debugLine="ts.bLabel= st";
_ts.bLabel = _st;
RDebugUtils.currentLine=1048615;
 //BA.debugLineNum = 1048615;BA.debugLine="ListeRdvParam.AddTwoLines2(ts.aLabel, ts.bLabel,";
mostCurrent._listerdvparam.AddTwoLines2(_ts.aLabel,_ts.bLabel,(Object)(_ts));
 }
};
RDebugUtils.currentLine=1048619;
 //BA.debugLineNum = 1048619;BA.debugLine="Enreg.Close";
_enreg.Close();
RDebugUtils.currentLine=1048620;
 //BA.debugLineNum = 1048620;BA.debugLine="maBase.Close";
_mabase.Close();
RDebugUtils.currentLine=1048622;
 //BA.debugLineNum = 1048622;BA.debugLine="End Sub";
return "";
}
public static String  _initlistes() throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("initlistes"))
	return (String) Debug.delegate(mostCurrent.activityBA, "initlistes", null);
long _i = 0L;
String _s = "";
RDebugUtils.currentLine=1179648;
 //BA.debugLineNum = 1179648;BA.debugLine="Sub InitListes";
RDebugUtils.currentLine=1179649;
 //BA.debugLineNum = 1179649;BA.debugLine="Dim i As Long";
_i = 0L;
RDebugUtils.currentLine=1179650;
 //BA.debugLineNum = 1179650;BA.debugLine="Dim s As String";
_s = "";
RDebugUtils.currentLine=1179653;
 //BA.debugLineNum = 1179653;BA.debugLine="lstJour.Add(\"jour\")";
mostCurrent._lstjour.Add("jour");
RDebugUtils.currentLine=1179654;
 //BA.debugLineNum = 1179654;BA.debugLine="For i = 1 To 31";
{
final long step4 = 1;
final long limit4 = (long) (31);
for (_i = (long) (1) ; (step4 > 0 && _i <= limit4) || (step4 < 0 && _i >= limit4); _i = ((long)(0 + _i + step4)) ) {
RDebugUtils.currentLine=1179655;
 //BA.debugLineNum = 1179655;BA.debugLine="s=NumberFormat(i,2,0)";
_s = anywheresoftware.b4a.keywords.Common.NumberFormat(_i,(int) (2),(int) (0));
RDebugUtils.currentLine=1179656;
 //BA.debugLineNum = 1179656;BA.debugLine="lstJour.Add(s)";
mostCurrent._lstjour.Add(_s);
 }
};
RDebugUtils.currentLine=1179659;
 //BA.debugLineNum = 1179659;BA.debugLine="lstmois.Add(\"mois\")";
mostCurrent._lstmois.Add("mois");
RDebugUtils.currentLine=1179660;
 //BA.debugLineNum = 1179660;BA.debugLine="For i = 1 To 12";
{
final long step9 = 1;
final long limit9 = (long) (12);
for (_i = (long) (1) ; (step9 > 0 && _i <= limit9) || (step9 < 0 && _i >= limit9); _i = ((long)(0 + _i + step9)) ) {
RDebugUtils.currentLine=1179661;
 //BA.debugLineNum = 1179661;BA.debugLine="s=NumberFormat(i,2,0)";
_s = anywheresoftware.b4a.keywords.Common.NumberFormat(_i,(int) (2),(int) (0));
RDebugUtils.currentLine=1179662;
 //BA.debugLineNum = 1179662;BA.debugLine="lstmois.Add(s)";
mostCurrent._lstmois.Add(_s);
 }
};
RDebugUtils.currentLine=1179665;
 //BA.debugLineNum = 1179665;BA.debugLine="lstAnnee.Add(\"année\")";
mostCurrent._lstannee.Add("année");
RDebugUtils.currentLine=1179666;
 //BA.debugLineNum = 1179666;BA.debugLine="For i = 2015 To 2050";
{
final long step14 = 1;
final long limit14 = (long) (2050);
for (_i = (long) (2015) ; (step14 > 0 && _i <= limit14) || (step14 < 0 && _i >= limit14); _i = ((long)(0 + _i + step14)) ) {
RDebugUtils.currentLine=1179667;
 //BA.debugLineNum = 1179667;BA.debugLine="lstAnnee.Add(i)";
mostCurrent._lstannee.Add(BA.NumberToString(_i));
 }
};
RDebugUtils.currentLine=1179670;
 //BA.debugLineNum = 1179670;BA.debugLine="lstHeure.Add(\"heure\")";
mostCurrent._lstheure.Add("heure");
RDebugUtils.currentLine=1179671;
 //BA.debugLineNum = 1179671;BA.debugLine="For i = 0 To 24";
{
final long step18 = 1;
final long limit18 = (long) (24);
for (_i = (long) (0) ; (step18 > 0 && _i <= limit18) || (step18 < 0 && _i >= limit18); _i = ((long)(0 + _i + step18)) ) {
RDebugUtils.currentLine=1179672;
 //BA.debugLineNum = 1179672;BA.debugLine="s=NumberFormat(i,2,0)";
_s = anywheresoftware.b4a.keywords.Common.NumberFormat(_i,(int) (2),(int) (0));
RDebugUtils.currentLine=1179673;
 //BA.debugLineNum = 1179673;BA.debugLine="lstHeure.Add(s)";
mostCurrent._lstheure.Add(_s);
 }
};
RDebugUtils.currentLine=1179676;
 //BA.debugLineNum = 1179676;BA.debugLine="lstMinute.Add(\"minutes\")";
mostCurrent._lstminute.Add("minutes");
RDebugUtils.currentLine=1179677;
 //BA.debugLineNum = 1179677;BA.debugLine="For i = 0 To 55 Step 5";
{
final long step23 = (long) (5);
final long limit23 = (long) (55);
for (_i = (long) (0) ; (step23 > 0 && _i <= limit23) || (step23 < 0 && _i >= limit23); _i = ((long)(0 + _i + step23)) ) {
RDebugUtils.currentLine=1179678;
 //BA.debugLineNum = 1179678;BA.debugLine="s=NumberFormat(i,2,0)";
_s = anywheresoftware.b4a.keywords.Common.NumberFormat(_i,(int) (2),(int) (0));
RDebugUtils.currentLine=1179679;
 //BA.debugLineNum = 1179679;BA.debugLine="lstMinute.Add(s)";
mostCurrent._lstminute.Add(_s);
 }
};
RDebugUtils.currentLine=1179682;
 //BA.debugLineNum = 1179682;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("activity_pause"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_pause", new Object[] {_userclosed});
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=851969;
 //BA.debugLineNum = 851969;BA.debugLine="End Sub";
return "";
}
public static String  _boutfermer_click() throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("boutfermer_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "boutfermer_click", null);
RDebugUtils.currentLine=983040;
 //BA.debugLineNum = 983040;BA.debugLine="Sub BoutFermer_Click";
RDebugUtils.currentLine=983042;
 //BA.debugLineNum = 983042;BA.debugLine="StartActivity(\"Main\")";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)("Main"));
RDebugUtils.currentLine=983044;
 //BA.debugLineNum = 983044;BA.debugLine="End Sub";
return "";
}
public static String  _boutmodif_click() throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("boutmodif_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "boutmodif_click", null);
String _stsql = "";
anywheresoftware.b4a.objects.IME _keyboard = null;
String _sdate = "";
String _sheure = "";
long _h = 0L;
RDebugUtils.currentLine=1769472;
 //BA.debugLineNum = 1769472;BA.debugLine="Sub BoutModif_Click";
RDebugUtils.currentLine=1769474;
 //BA.debugLineNum = 1769474;BA.debugLine="Dim stsql As String";
_stsql = "";
RDebugUtils.currentLine=1769475;
 //BA.debugLineNum = 1769475;BA.debugLine="Dim keyboard As IME";
_keyboard = new anywheresoftware.b4a.objects.IME();
RDebugUtils.currentLine=1769476;
 //BA.debugLineNum = 1769476;BA.debugLine="Dim sDate, sHeure As String";
_sdate = "";
_sheure = "";
RDebugUtils.currentLine=1769477;
 //BA.debugLineNum = 1769477;BA.debugLine="Dim H As Long";
_h = 0L;
RDebugUtils.currentLine=1769480;
 //BA.debugLineNum = 1769480;BA.debugLine="keyboard.Initialize(\"\")";
_keyboard.Initialize("");
RDebugUtils.currentLine=1769481;
 //BA.debugLineNum = 1769481;BA.debugLine="keyboard.HideKeyboard";
_keyboard.HideKeyboard(mostCurrent.activityBA);
RDebugUtils.currentLine=1769484;
 //BA.debugLineNum = 1769484;BA.debugLine="If VerifSaisie<>\"Indiquer \" Then";
if ((_verifsaisie()).equals("Indiquer ") == false) { 
RDebugUtils.currentLine=1769485;
 //BA.debugLineNum = 1769485;BA.debugLine="Msgbox(VerifSaisie, \"Erreur\")";
anywheresoftware.b4a.keywords.Common.Msgbox(_verifsaisie(),"Erreur",mostCurrent.activityBA);
RDebugUtils.currentLine=1769486;
 //BA.debugLineNum = 1769486;BA.debugLine="Return";
if (true) return "";
 };
RDebugUtils.currentLine=1769497;
 //BA.debugLineNum = 1769497;BA.debugLine="sDate=ljour & \"/\" & lmois & \"/\" & lannee";
_sdate = mostCurrent._ljour+"/"+mostCurrent._lmois+"/"+mostCurrent._lannee;
RDebugUtils.currentLine=1769498;
 //BA.debugLineNum = 1769498;BA.debugLine="sHeure=lheure & \":\" & lminute";
_sheure = mostCurrent._lheure+":"+mostCurrent._lminute;
RDebugUtils.currentLine=1769499;
 //BA.debugLineNum = 1769499;BA.debugLine="H=Module1.StringToDateHeure(sDate, sHeure)";
_h = mostCurrent._module1._stringtodateheure(mostCurrent.activityBA,_sdate,_sheure);
RDebugUtils.currentLine=1769501;
 //BA.debugLineNum = 1769501;BA.debugLine="stsql=\"UPDATE rdv SET dateheure=\" & H & \", libell";
_stsql = "UPDATE rdv SET dateheure="+BA.NumberToString(_h)+", libelle='"+mostCurrent._txtlibelle.getText()+"' WHERE nordv = "+mostCurrent._lbllabela;
RDebugUtils.currentLine=1769504;
 //BA.debugLineNum = 1769504;BA.debugLine="maBase.ExecNonQuery(stsql)";
_mabase.ExecNonQuery(_stsql);
RDebugUtils.currentLine=1769506;
 //BA.debugLineNum = 1769506;BA.debugLine="ToastMessageShow(\"Rendez vous modifié\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Rendez vous modifié",anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=1769510;
 //BA.debugLineNum = 1769510;BA.debugLine="RazListes";
_razlistes();
RDebugUtils.currentLine=1769511;
 //BA.debugLineNum = 1769511;BA.debugLine="lireBase";
_lirebase();
RDebugUtils.currentLine=1769514;
 //BA.debugLineNum = 1769514;BA.debugLine="boutValid.Visible=True";
mostCurrent._boutvalid.setVisible(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=1769515;
 //BA.debugLineNum = 1769515;BA.debugLine="boutModif.visible=False";
mostCurrent._boutmodif.setVisible(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=1769517;
 //BA.debugLineNum = 1769517;BA.debugLine="End Sub";
return "";
}
public static String  _verifsaisie() throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("verifsaisie"))
	return (String) Debug.delegate(mostCurrent.activityBA, "verifsaisie", null);
String _msg = "";
RDebugUtils.currentLine=1572864;
 //BA.debugLineNum = 1572864;BA.debugLine="Sub VerifSaisie As String";
RDebugUtils.currentLine=1572866;
 //BA.debugLineNum = 1572866;BA.debugLine="Dim msg As String = \"Indiquer \"";
_msg = "Indiquer ";
RDebugUtils.currentLine=1572867;
 //BA.debugLineNum = 1572867;BA.debugLine="If ljour=\"\" Or ljour=\"jour\" Then msg=msg & \"Jour";
if ((mostCurrent._ljour).equals("") || (mostCurrent._ljour).equals("jour")) { 
_msg = _msg+"Jour ";};
RDebugUtils.currentLine=1572868;
 //BA.debugLineNum = 1572868;BA.debugLine="If lmois=\"\" Or lmois=\"mois\" Then msg=msg & \"Mois";
if ((mostCurrent._lmois).equals("") || (mostCurrent._lmois).equals("mois")) { 
_msg = _msg+"Mois ";};
RDebugUtils.currentLine=1572869;
 //BA.debugLineNum = 1572869;BA.debugLine="If lannee=\"\" Or lannee=\"année\" Then msg=msg & \"An";
if ((mostCurrent._lannee).equals("") || (mostCurrent._lannee).equals("année")) { 
_msg = _msg+"Annee ";};
RDebugUtils.currentLine=1572870;
 //BA.debugLineNum = 1572870;BA.debugLine="If lheure=\"\" Or lheure=\"heure\" Then msg=msg & \"He";
if ((mostCurrent._lheure).equals("") || (mostCurrent._lheure).equals("heure")) { 
_msg = _msg+"Heure ";};
RDebugUtils.currentLine=1572871;
 //BA.debugLineNum = 1572871;BA.debugLine="If lminute=\"\" Or lminute=\"minutes\" Then msg=msg &";
if ((mostCurrent._lminute).equals("") || (mostCurrent._lminute).equals("minutes")) { 
_msg = _msg+"Minutes ";};
RDebugUtils.currentLine=1572872;
 //BA.debugLineNum = 1572872;BA.debugLine="If txtLibelle.Text=\"\" Then msg=msg & \"Libelle \"";
if ((mostCurrent._txtlibelle.getText()).equals("")) { 
_msg = _msg+"Libelle ";};
RDebugUtils.currentLine=1572873;
 //BA.debugLineNum = 1572873;BA.debugLine="Return msg";
if (true) return _msg;
RDebugUtils.currentLine=1572874;
 //BA.debugLineNum = 1572874;BA.debugLine="End Sub";
return "";
}
public static String  _razlistes() throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("razlistes"))
	return (String) Debug.delegate(mostCurrent.activityBA, "razlistes", null);
RDebugUtils.currentLine=1638400;
 //BA.debugLineNum = 1638400;BA.debugLine="Sub RazListes";
RDebugUtils.currentLine=1638401;
 //BA.debugLineNum = 1638401;BA.debugLine="lstJour.SelectedIndex=0";
mostCurrent._lstjour.setSelectedIndex((int) (0));
RDebugUtils.currentLine=1638402;
 //BA.debugLineNum = 1638402;BA.debugLine="lstmois.SelectedIndex=0";
mostCurrent._lstmois.setSelectedIndex((int) (0));
RDebugUtils.currentLine=1638403;
 //BA.debugLineNum = 1638403;BA.debugLine="lstAnnee.SelectedIndex=0";
mostCurrent._lstannee.setSelectedIndex((int) (0));
RDebugUtils.currentLine=1638404;
 //BA.debugLineNum = 1638404;BA.debugLine="lstHeure.SelectedIndex=0";
mostCurrent._lstheure.setSelectedIndex((int) (0));
RDebugUtils.currentLine=1638405;
 //BA.debugLineNum = 1638405;BA.debugLine="lstMinute.SelectedIndex=0";
mostCurrent._lstminute.setSelectedIndex((int) (0));
RDebugUtils.currentLine=1638406;
 //BA.debugLineNum = 1638406;BA.debugLine="txtLibelle.Text=\"\"";
mostCurrent._txtlibelle.setText((Object)(""));
RDebugUtils.currentLine=1638407;
 //BA.debugLineNum = 1638407;BA.debugLine="End Sub";
return "";
}
public static String  _bouttousrdv_checkedchange(boolean _checked) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("bouttousrdv_checkedchange"))
	return (String) Debug.delegate(mostCurrent.activityBA, "bouttousrdv_checkedchange", new Object[] {_checked});
RDebugUtils.currentLine=1900544;
 //BA.debugLineNum = 1900544;BA.debugLine="Sub boutTousRdv_CheckedChange(Checked As Boolean)";
RDebugUtils.currentLine=1900546;
 //BA.debugLineNum = 1900546;BA.debugLine="lireBase";
_lirebase();
RDebugUtils.currentLine=1900548;
 //BA.debugLineNum = 1900548;BA.debugLine="End Sub";
return "";
}
public static String  _boutvalid_click() throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("boutvalid_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "boutvalid_click", null);
anywheresoftware.b4a.objects.IME _keyboard = null;
String _sdate = "";
String _sheure = "";
long _h = 0L;
RDebugUtils.currentLine=1114112;
 //BA.debugLineNum = 1114112;BA.debugLine="Sub boutValid_Click 'Nouveau rdv";
RDebugUtils.currentLine=1114114;
 //BA.debugLineNum = 1114114;BA.debugLine="Dim keyboard As IME";
_keyboard = new anywheresoftware.b4a.objects.IME();
RDebugUtils.currentLine=1114115;
 //BA.debugLineNum = 1114115;BA.debugLine="Dim sDate, sHeure As String";
_sdate = "";
_sheure = "";
RDebugUtils.currentLine=1114116;
 //BA.debugLineNum = 1114116;BA.debugLine="Dim H As Long";
_h = 0L;
RDebugUtils.currentLine=1114119;
 //BA.debugLineNum = 1114119;BA.debugLine="keyboard.Initialize(\"\")";
_keyboard.Initialize("");
RDebugUtils.currentLine=1114120;
 //BA.debugLineNum = 1114120;BA.debugLine="keyboard.HideKeyboard";
_keyboard.HideKeyboard(mostCurrent.activityBA);
RDebugUtils.currentLine=1114123;
 //BA.debugLineNum = 1114123;BA.debugLine="If VerifSaisie<>\"Indiquer \" Then";
if ((_verifsaisie()).equals("Indiquer ") == false) { 
RDebugUtils.currentLine=1114124;
 //BA.debugLineNum = 1114124;BA.debugLine="Msgbox(VerifSaisie, \"Erreur\")";
anywheresoftware.b4a.keywords.Common.Msgbox(_verifsaisie(),"Erreur",mostCurrent.activityBA);
RDebugUtils.currentLine=1114125;
 //BA.debugLineNum = 1114125;BA.debugLine="Return";
if (true) return "";
 };
RDebugUtils.currentLine=1114129;
 //BA.debugLineNum = 1114129;BA.debugLine="Try";
try {RDebugUtils.currentLine=1114130;
 //BA.debugLineNum = 1114130;BA.debugLine="maBase.Initialize(Main.DBDirName, Main.DBFileNam";
_mabase.Initialize(mostCurrent._main._dbdirname,mostCurrent._main._dbfilename,anywheresoftware.b4a.keywords.Common.True);
 } 
       catch (Exception e89) {
			processBA.setLastException(e89);RDebugUtils.currentLine=1114132;
 //BA.debugLineNum = 1114132;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
 };
RDebugUtils.currentLine=1114136;
 //BA.debugLineNum = 1114136;BA.debugLine="sDate=ljour & \"/\" & lmois & \"/\" & lannee";
_sdate = mostCurrent._ljour+"/"+mostCurrent._lmois+"/"+mostCurrent._lannee;
RDebugUtils.currentLine=1114137;
 //BA.debugLineNum = 1114137;BA.debugLine="sHeure=lheure & \":\" & lminute";
_sheure = mostCurrent._lheure+":"+mostCurrent._lminute;
RDebugUtils.currentLine=1114138;
 //BA.debugLineNum = 1114138;BA.debugLine="H=Module1.StringToDateHeure(sDate, sHeure)";
_h = mostCurrent._module1._stringtodateheure(mostCurrent.activityBA,_sdate,_sheure);
RDebugUtils.currentLine=1114141;
 //BA.debugLineNum = 1114141;BA.debugLine="Try";
try {RDebugUtils.currentLine=1114142;
 //BA.debugLineNum = 1114142;BA.debugLine="maBase.ExecNonQuery(\"INSERT INTO rdv VALUES (nul";
_mabase.ExecNonQuery("INSERT INTO rdv VALUES (null,'"+BA.NumberToString(_h)+"','"+mostCurrent._txtlibelle.getText()+"',null)");
 } 
       catch (Exception e97) {
			processBA.setLastException(e97);RDebugUtils.currentLine=1114144;
 //BA.debugLineNum = 1114144;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
RDebugUtils.currentLine=1114145;
 //BA.debugLineNum = 1114145;BA.debugLine="Return";
if (true) return "";
 };
RDebugUtils.currentLine=1114148;
 //BA.debugLineNum = 1114148;BA.debugLine="ToastMessageShow(\"Rendez vous créé\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Rendez vous créé",anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=1114151;
 //BA.debugLineNum = 1114151;BA.debugLine="maBase.Close";
_mabase.Close();
RDebugUtils.currentLine=1114152;
 //BA.debugLineNum = 1114152;BA.debugLine="RazListes";
_razlistes();
RDebugUtils.currentLine=1114153;
 //BA.debugLineNum = 1114153;BA.debugLine="lireBase";
_lirebase();
RDebugUtils.currentLine=1114155;
 //BA.debugLineNum = 1114155;BA.debugLine="End Sub";
return "";
}
public static String  _listerdvparam_itemclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("listerdvparam_itemclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "listerdvparam_itemclick", new Object[] {_position,_value});
b4a.example.param._twostrings _ts = null;
RDebugUtils.currentLine=1835008;
 //BA.debugLineNum = 1835008;BA.debugLine="Sub ListeRdvParam_ItemClick (Position As Int, Valu";
RDebugUtils.currentLine=1835010;
 //BA.debugLineNum = 1835010;BA.debugLine="Dim ts As twoStrings";
_ts = new b4a.example.param._twostrings();
RDebugUtils.currentLine=1835015;
 //BA.debugLineNum = 1835015;BA.debugLine="ts.Initialize";
_ts.Initialize();
RDebugUtils.currentLine=1835016;
 //BA.debugLineNum = 1835016;BA.debugLine="ts=Value";
_ts = (b4a.example.param._twostrings)(_value);
RDebugUtils.currentLine=1835017;
 //BA.debugLineNum = 1835017;BA.debugLine="lblLabelA=ts.aLabel";
mostCurrent._lbllabela = _ts.aLabel;
RDebugUtils.currentLine=1835018;
 //BA.debugLineNum = 1835018;BA.debugLine="lblLabelB=ts.bLabel";
mostCurrent._lbllabelb = _ts.bLabel;
RDebugUtils.currentLine=1835019;
 //BA.debugLineNum = 1835019;BA.debugLine="Msgbox(Position & \"/\" & lblLabelA & \"/\" & lblLabe";
anywheresoftware.b4a.keywords.Common.Msgbox(BA.NumberToString(_position)+"/"+mostCurrent._lbllabela+"/"+mostCurrent._lbllabelb,"",mostCurrent.activityBA);
RDebugUtils.currentLine=1835025;
 //BA.debugLineNum = 1835025;BA.debugLine="End Sub";
return "";
}
public static String  _listerdvparam_itemlongclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("listerdvparam_itemlongclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "listerdvparam_itemlongclick", new Object[] {_position,_value});
b4a.example.param._twostrings _ts = null;
int _reponse = 0;
String _stsql = "";
String _val = "";
anywheresoftware.b4a.sql.SQL.CursorWrapper _enregistrement = null;
long _t = 0L;
RDebugUtils.currentLine=1703936;
 //BA.debugLineNum = 1703936;BA.debugLine="Sub ListeRdvParam_itemlongclick(Position As Int, V";
RDebugUtils.currentLine=1703938;
 //BA.debugLineNum = 1703938;BA.debugLine="Dim ts As twoStrings";
_ts = new b4a.example.param._twostrings();
RDebugUtils.currentLine=1703941;
 //BA.debugLineNum = 1703941;BA.debugLine="ts.Initialize";
_ts.Initialize();
RDebugUtils.currentLine=1703942;
 //BA.debugLineNum = 1703942;BA.debugLine="ts=Value";
_ts = (b4a.example.param._twostrings)(_value);
RDebugUtils.currentLine=1703943;
 //BA.debugLineNum = 1703943;BA.debugLine="lblLabelA=ts.aLabel";
mostCurrent._lbllabela = _ts.aLabel;
RDebugUtils.currentLine=1703944;
 //BA.debugLineNum = 1703944;BA.debugLine="lblLabelB=ts.bLabel";
mostCurrent._lbllabelb = _ts.bLabel;
RDebugUtils.currentLine=1703947;
 //BA.debugLineNum = 1703947;BA.debugLine="Try";
try {RDebugUtils.currentLine=1703948;
 //BA.debugLineNum = 1703948;BA.debugLine="maBase.Initialize(Main.DBDirName, Main.DBFileNam";
_mabase.Initialize(mostCurrent._main._dbdirname,mostCurrent._main._dbfilename,anywheresoftware.b4a.keywords.Common.True);
 } 
       catch (Exception e175) {
			processBA.setLastException(e175);RDebugUtils.currentLine=1703950;
 //BA.debugLineNum = 1703950;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
 };
RDebugUtils.currentLine=1703954;
 //BA.debugLineNum = 1703954;BA.debugLine="Dim Reponse As Int = Msgbox2(\"Voulez vous supprim";
_reponse = anywheresoftware.b4a.keywords.Common.Msgbox2("Voulez vous supprimer ou modifier cet enregistrement ?"+mostCurrent._lbllabela,"Mise à jour","Modifier","Annuler","Supprimer",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA);
RDebugUtils.currentLine=1703956;
 //BA.debugLineNum = 1703956;BA.debugLine="Select Case Reponse";
switch (BA.switchObjectToInt(_reponse,anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE,anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL,anywheresoftware.b4a.keywords.Common.DialogResponse.NEGATIVE)) {
case 0: {
RDebugUtils.currentLine=1703960;
 //BA.debugLineNum = 1703960;BA.debugLine="Dim stSql, Val  As String";
_stsql = "";
_val = "";
RDebugUtils.currentLine=1703961;
 //BA.debugLineNum = 1703961;BA.debugLine="Dim Enregistrement As Cursor";
_enregistrement = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
RDebugUtils.currentLine=1703962;
 //BA.debugLineNum = 1703962;BA.debugLine="Dim t As Long";
_t = 0L;
RDebugUtils.currentLine=1703964;
 //BA.debugLineNum = 1703964;BA.debugLine="stSql=\"SELECT dateheure, libelle FROM rdv WHER";
_stsql = "SELECT dateheure, libelle FROM rdv WHERE nordv = "+mostCurrent._lbllabela;
RDebugUtils.currentLine=1703967;
 //BA.debugLineNum = 1703967;BA.debugLine="Try";
try {RDebugUtils.currentLine=1703968;
 //BA.debugLineNum = 1703968;BA.debugLine="Enregistrement=maBase.ExecQuery(stSql)";
_enregistrement.setObject((android.database.Cursor)(_mabase.ExecQuery(_stsql)));
 } 
       catch (Exception e187) {
			processBA.setLastException(e187);RDebugUtils.currentLine=1703970;
 //BA.debugLineNum = 1703970;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
 };
RDebugUtils.currentLine=1703974;
 //BA.debugLineNum = 1703974;BA.debugLine="Enregistrement.Position=0";
_enregistrement.setPosition((int) (0));
RDebugUtils.currentLine=1703975;
 //BA.debugLineNum = 1703975;BA.debugLine="t=Enregistrement.GetString(\"dateheure\")";
_t = (long)(Double.parseDouble(_enregistrement.GetString("dateheure")));
RDebugUtils.currentLine=1703976;
 //BA.debugLineNum = 1703976;BA.debugLine="Val=Enregistrement.GetString(\"libelle\")";
_val = _enregistrement.GetString("libelle");
RDebugUtils.currentLine=1703979;
 //BA.debugLineNum = 1703979;BA.debugLine="ljour=DateTime.GetDayOfMonth(t)";
mostCurrent._ljour = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(_t));
RDebugUtils.currentLine=1703980;
 //BA.debugLineNum = 1703980;BA.debugLine="lstJour.SelectedIndex=ljour";
mostCurrent._lstjour.setSelectedIndex((int)(Double.parseDouble(mostCurrent._ljour)));
RDebugUtils.currentLine=1703981;
 //BA.debugLineNum = 1703981;BA.debugLine="lmois=DateTime.GetMonth(t)";
mostCurrent._lmois = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(_t));
RDebugUtils.currentLine=1703982;
 //BA.debugLineNum = 1703982;BA.debugLine="lstmois.SelectedIndex=lmois";
mostCurrent._lstmois.setSelectedIndex((int)(Double.parseDouble(mostCurrent._lmois)));
RDebugUtils.currentLine=1703983;
 //BA.debugLineNum = 1703983;BA.debugLine="lannee=DateTime.GetYear(t)";
mostCurrent._lannee = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetYear(_t));
RDebugUtils.currentLine=1703984;
 //BA.debugLineNum = 1703984;BA.debugLine="lstAnnee.SelectedIndex=lannee-2014";
mostCurrent._lstannee.setSelectedIndex((int) ((double)(Double.parseDouble(mostCurrent._lannee))-2014));
RDebugUtils.currentLine=1703986;
 //BA.debugLineNum = 1703986;BA.debugLine="lheure=DateTime.GetHour(t)";
mostCurrent._lheure = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetHour(_t));
RDebugUtils.currentLine=1703987;
 //BA.debugLineNum = 1703987;BA.debugLine="lstHeure.SelectedIndex=lheure+1";
mostCurrent._lstheure.setSelectedIndex((int) ((double)(Double.parseDouble(mostCurrent._lheure))+1));
RDebugUtils.currentLine=1703988;
 //BA.debugLineNum = 1703988;BA.debugLine="lminute=DateTime.GetMinute(t)";
mostCurrent._lminute = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetMinute(_t));
RDebugUtils.currentLine=1703989;
 //BA.debugLineNum = 1703989;BA.debugLine="lstMinute.SelectedIndex=lminute/5+1";
mostCurrent._lstminute.setSelectedIndex((int) ((double)(Double.parseDouble(mostCurrent._lminute))/(double)5+1));
RDebugUtils.currentLine=1703991;
 //BA.debugLineNum = 1703991;BA.debugLine="txtLibelle.Text=Val";
mostCurrent._txtlibelle.setText((Object)(_val));
RDebugUtils.currentLine=1703994;
 //BA.debugLineNum = 1703994;BA.debugLine="boutValid.Visible=False";
mostCurrent._boutvalid.setVisible(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=1703995;
 //BA.debugLineNum = 1703995;BA.debugLine="boutModif.visible=True";
mostCurrent._boutmodif.setVisible(anywheresoftware.b4a.keywords.Common.True);
 break; }
case 1: {
RDebugUtils.currentLine=1703998;
 //BA.debugLineNum = 1703998;BA.debugLine="Return";
if (true) return "";
 break; }
case 2: {
RDebugUtils.currentLine=1704002;
 //BA.debugLineNum = 1704002;BA.debugLine="If Msgbox2(\"Confirmer la suppression de ce rend";
if (anywheresoftware.b4a.keywords.Common.Msgbox2("Confirmer la suppression de ce rendez-vous"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)))+mostCurrent._lbllabelb,"Supression","Supprimer","Annuler","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA)==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
RDebugUtils.currentLine=1704004;
 //BA.debugLineNum = 1704004;BA.debugLine="stSql=\"DELETE FROM rdv WHERE nordv = \" & lblLa";
_stsql = "DELETE FROM rdv WHERE nordv = "+mostCurrent._lbllabela;
RDebugUtils.currentLine=1704007;
 //BA.debugLineNum = 1704007;BA.debugLine="Try";
try {RDebugUtils.currentLine=1704008;
 //BA.debugLineNum = 1704008;BA.debugLine="maBase.ExecNonQuery(stSql)";
_mabase.ExecNonQuery(_stsql);
 } 
       catch (Exception e213) {
			processBA.setLastException(e213);RDebugUtils.currentLine=1704010;
 //BA.debugLineNum = 1704010;BA.debugLine="Msgbox(LastException.Message,\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"",mostCurrent.activityBA);
 };
RDebugUtils.currentLine=1704013;
 //BA.debugLineNum = 1704013;BA.debugLine="ToastMessageShow(\"Rendez vous supprimé\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Rendez vous supprimé",anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=1704015;
 //BA.debugLineNum = 1704015;BA.debugLine="lireBase";
_lirebase();
 }else {
RDebugUtils.currentLine=1704017;
 //BA.debugLineNum = 1704017;BA.debugLine="Return";
if (true) return "";
 };
 break; }
}
;
RDebugUtils.currentLine=1704023;
 //BA.debugLineNum = 1704023;BA.debugLine="maBase.Close";
_mabase.Close();
RDebugUtils.currentLine=1704025;
 //BA.debugLineNum = 1704025;BA.debugLine="End Sub";
return "";
}
public static String  _lstannee_itemclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("lstannee_itemclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "lstannee_itemclick", new Object[] {_position,_value});
RDebugUtils.currentLine=1507328;
 //BA.debugLineNum = 1507328;BA.debugLine="Sub lstAnnee_ItemClick (Position As Int, Value As";
RDebugUtils.currentLine=1507329;
 //BA.debugLineNum = 1507329;BA.debugLine="lannee=Value";
mostCurrent._lannee = BA.ObjectToString(_value);
RDebugUtils.currentLine=1507330;
 //BA.debugLineNum = 1507330;BA.debugLine="End Sub";
return "";
}
public static String  _lstheure_itemclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("lstheure_itemclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "lstheure_itemclick", new Object[] {_position,_value});
RDebugUtils.currentLine=1441792;
 //BA.debugLineNum = 1441792;BA.debugLine="Sub lstHeure_ItemClick (Position As Int, Value As";
RDebugUtils.currentLine=1441793;
 //BA.debugLineNum = 1441793;BA.debugLine="lheure=Value";
mostCurrent._lheure = BA.ObjectToString(_value);
RDebugUtils.currentLine=1441794;
 //BA.debugLineNum = 1441794;BA.debugLine="End Sub";
return "";
}
public static String  _lstjour_itemclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("lstjour_itemclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "lstjour_itemclick", new Object[] {_position,_value});
RDebugUtils.currentLine=1376256;
 //BA.debugLineNum = 1376256;BA.debugLine="Sub lstJour_ItemClick (Position As Int, Value As O";
RDebugUtils.currentLine=1376257;
 //BA.debugLineNum = 1376257;BA.debugLine="ljour=Value";
mostCurrent._ljour = BA.ObjectToString(_value);
RDebugUtils.currentLine=1376258;
 //BA.debugLineNum = 1376258;BA.debugLine="End Sub";
return "";
}
public static String  _lstminute_itemclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("lstminute_itemclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "lstminute_itemclick", new Object[] {_position,_value});
RDebugUtils.currentLine=1310720;
 //BA.debugLineNum = 1310720;BA.debugLine="Sub lstMinute_ItemClick (Position As Int, Value As";
RDebugUtils.currentLine=1310721;
 //BA.debugLineNum = 1310721;BA.debugLine="lminute=Value";
mostCurrent._lminute = BA.ObjectToString(_value);
RDebugUtils.currentLine=1310722;
 //BA.debugLineNum = 1310722;BA.debugLine="End Sub";
return "";
}
public static String  _lstmois_itemclick(int _position,Object _value) throws Exception{
RDebugUtils.currentModule="param";
if (Debug.shouldDelegate("lstmois_itemclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "lstmois_itemclick", new Object[] {_position,_value});
RDebugUtils.currentLine=1245184;
 //BA.debugLineNum = 1245184;BA.debugLine="Sub lstmois_ItemClick (Position As Int, Value As O";
RDebugUtils.currentLine=1245185;
 //BA.debugLineNum = 1245185;BA.debugLine="lmois=Value";
mostCurrent._lmois = BA.ObjectToString(_value);
RDebugUtils.currentLine=1245186;
 //BA.debugLineNum = 1245186;BA.debugLine="End Sub";
return "";
}
}